import time

from upload.converter import soap
from upload.fam.session import _SessionService


class SoapDictSession(object):
    def __init__(self, node, dictId, converter):
        self.node = node
        self.dictId = dictId
        self.timeActive = time.time()
        self.converter = converter


class SoapSessionService(_SessionService):
    is_cash = True
    default_nes_server = None
    default_status_server = None

    def __init__(self, is_cash=True, default_nes_server=None, default_status_server=None):
        super(SoapSessionService, self).__init__(loggerType='soap')
        self.is_cash = is_cash
        self.default_status_server = default_status_server
        self.default_nes_server = default_nes_server

    def start_session_worker(self, node, dictionary_id):
        soapConverter = soap.SoapConverter(node)
        result = soapConverter.start()
        if result.result:
            self.sessions[self.get_session_id(node.id, dictionary_id)] = SoapDictSession(node, dictionary_id,
                                                                                         soapConverter)
        return {u'success': result.result, 'info': result.info}

    def stop_session_worker(self, node):
        return node.converter.stop()

    def rollback_session_worker(self, node, session_idle):
        return node.converter.rollback(sessionIdle=session_idle)
